freedombone-app-koel 26KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # koel application
  12. # https://gist.github.com/bplower/613a99156d603abac083
  13. #
  14. # License
  15. # =======
  16. #
  17. # Copyright (C) 2017 Bob Mottram <bob@freedombone.net>
  18. #
  19. # This program is free software: you can redistribute it and/or modify
  20. # it under the terms of the GNU Affero General Public License as published by
  21. # the Free Software Foundation, either version 3 of the License, or
  22. # (at your option) any later version.
  23. #
  24. # This program is distributed in the hope that it will be useful,
  25. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  26. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  27. # GNU Affero General Public License for more details.
  28. #
  29. # You should have received a copy of the GNU Affero General Public License
  30. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  31. VARIANTS='full full-vim media'
  32. IN_DEFAULT_INSTALL=0
  33. SHOW_ON_ABOUT=1
  34. KOEL_DOMAIN_NAME=
  35. KOEL_CODE=
  36. KOEL_ONION_PORT=8118
  37. KOEL_PORT=9002
  38. KOEL_REPO="https://github.com/phanan/koel"
  39. KOEL_COMMIT='70464a'
  40. KOEL_ADMIN_PASSWORD=
  41. koel_variables=(ONION_ONLY
  42. KOEL_DOMAIN_NAME
  43. KOEL_CODE
  44. DDNS_PROVIDER
  45. MY_EMAIL_ADDRESS
  46. MY_USERNAME)
  47. function logging_on_koel {
  48. echo -n ''
  49. }
  50. function logging_off_koel {
  51. echo -n ''
  52. }
  53. function koel_remove_gravatar {
  54. cd /var/www/${KOEL_DOMAIN_NAME}/htdocs
  55. sed -i "s|www.gravatar.com|${KOEL_DOMAIN_NAME}|g" node_modules/browser-sync-ui/public/js/app.js.map
  56. sed -i "s|www.gravatar.com|${KOEL_DOMAIN_NAME}|g" public/js/app.*.js
  57. if ! grep -q "//Vue.set(user, 'avatar'" resources/assets/js/stores/user.js; then
  58. sed -i "s|Vue.set(user, 'avatar'|//Vue.set(user, 'avatar'|g" resources/assets/js/stores/user.js
  59. fi
  60. }
  61. function remove_user_koel {
  62. remove_username="$1"
  63. ${PROJECT_NAME}-pass -u $remove_username --rmapp koel
  64. }
  65. function add_user_koel {
  66. new_username="$1"
  67. new_user_password="$2"
  68. ${PROJECT_NAME}-pass -u $new_username -a koel -p "$new_user_password"
  69. echo '0'
  70. }
  71. function install_interactive_koel {
  72. if [ ! $ONION_ONLY ]; then
  73. ONION_ONLY='no'
  74. fi
  75. if [[ $ONION_ONLY != "no" ]]; then
  76. KOEL_DOMAIN_NAME='koel.local'
  77. else
  78. KOEL_DETAILS_COMPLETE=
  79. while [ ! $KOEL_DETAILS_COMPLETE ]
  80. do
  81. data=$(tempfile 2>/dev/null)
  82. trap "rm -f $data" 0 1 2 5 15
  83. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  84. dialog --backtitle $"Freedombone Configuration" \
  85. --title $"Koel Configuration" \
  86. --form $"\nPlease enter your Koel details. The background image URL can be left blank.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 3 \
  87. $"Domain:" 1 1 "$(grep 'KOEL_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  88. $"Code:" 2 1 "$(grep 'KOEL_CODE' temp.cfg | awk -F '=' '{print $2}')" 2 25 33 255 \
  89. 2> $data
  90. else
  91. dialog --backtitle $"Freedombone Configuration" \
  92. --title $"Koel Configuration" \
  93. --form $"\nPlease enter your Koel details. The background image URL can be left blank.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 3 \
  94. $"Domain:" 1 1 "$(grep 'KOEL_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  95. 2> $data
  96. fi
  97. sel=$?
  98. case $sel in
  99. 1) exit 1;;
  100. 255) exit 1;;
  101. esac
  102. KOEL_DOMAIN_NAME=$(cat $data | sed -n 1p)
  103. if [ $KOEL_DOMAIN_NAME ]; then
  104. if [[ $KOEL_DOMAIN_NAME == "$HUBZILLA_DOMAIN_NAME" ]]; then
  105. KOEL_DOMAIN_NAME=""
  106. fi
  107. TEST_DOMAIN_NAME=$KOEL_DOMAIN_NAME
  108. validate_domain_name
  109. if [[ $TEST_DOMAIN_NAME != $KOEL_DOMAIN_NAME ]]; then
  110. KOEL_DOMAIN_NAME=
  111. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  112. else
  113. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  114. KOEL_CODE=$(cat $data | sed -n 2p)
  115. validate_freedns_code "$KOEL_CODE"
  116. if [ ! $VALID_CODE ]; then
  117. KOEL_DOMAIN_NAME=
  118. fi
  119. fi
  120. fi
  121. fi
  122. if [ $KOEL_DOMAIN_NAME ]; then
  123. KOEL_DETAILS_COMPLETE="yes"
  124. fi
  125. done
  126. # save the results in the config file
  127. write_config_param "KOEL_CODE" "$KOEL_CODE"
  128. fi
  129. write_config_param "KOEL_DOMAIN_NAME" "$KOEL_DOMAIN_NAME"
  130. APP_INSTALLED=1
  131. }
  132. function change_password_koel {
  133. curr_username="$1"
  134. new_user_password="$2"
  135. read_config_param 'KOEL_DOMAIN_NAME'
  136. ${PROJECT_NAME}-pass -u "$curr_username" -a koel -p "$new_user_password"
  137. }
  138. function koel_create_database {
  139. if [ -f $IMAGE_PASSWORD_FILE ]; then
  140. KOEL_ADMIN_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  141. else
  142. if [ ! $KOEL_ADMIN_PASSWORD ]; then
  143. KOEL_ADMIN_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  144. fi
  145. fi
  146. if [ ! $KOEL_ADMIN_PASSWORD ]; then
  147. return
  148. fi
  149. function_check create_database
  150. create_database koel "$KOEL_ADMIN_PASSWORD" $MY_USERNAME
  151. }
  152. function reconfigure_koel {
  153. echo -n ''
  154. }
  155. function koel_import_from_directory {
  156. data=$(tempfile 2>/dev/null)
  157. dialog --title "Choose a directory containing music" --dselect /home/$MY_USERNAME/ 30 60 2> $data
  158. selected_dir=$(cat $data)
  159. rm $data
  160. if [[ "$selected_dir" == '/music' ]]; then
  161. return
  162. fi
  163. if [ ! -d $selected_dir ]; then
  164. return
  165. fi
  166. if [[ "$selected_dir" == "/home/$MY_USERNAME/" ]]; then
  167. return
  168. fi
  169. if [[ "$selected_dir" == "/home/$MY_USERNAME/."* ]]; then
  170. return
  171. fi
  172. if [[ "$selected_dir" == *"/Maildir" || "$selected_dir" == *"/Sync" ]]; then
  173. return
  174. fi
  175. dialog --title $"Import music directory" \
  176. --backtitle $"Freedombone Control Panel" \
  177. --defaultno \
  178. --yesno $"\nImport the directory:\n\n $selected_dir" 12 75
  179. sel=$?
  180. case $sel in
  181. 1) return;;
  182. 255) return;;
  183. esac
  184. mv "$selected_dir" /music
  185. dialog --title $"Import music directory" \
  186. --msgbox $"Import success. You may need to re-sync within Koel." 6 40
  187. }
  188. function koel_import_from_usb {
  189. clear
  190. detect_usb_drive
  191. if [ ! -b $USB_DRIVE ]; then
  192. dialog --title $"Import music from USB drive" --msgbox $'No USB drive found' 6 50
  193. return
  194. fi
  195. backup_mount_drive ${USB_DRIVE}
  196. if [ ! -d $USB_MOUNT/Music ]; then
  197. dialog --title $"Import music from USB drive" --msgbox $'No Music directory found on USB drive' 6 50
  198. backup_unmount_drive ${USB_DRIVE}
  199. fi
  200. cp -ru $USB_MOUNT/Music/* /music
  201. backup_unmount_drive ${USB_DRIVE}
  202. dialog --title $"Import music from USB drive" --msgbox $'Import complete. You may now remove the USB drive' 6 50
  203. }
  204. function koel_export_to_usb {
  205. clear
  206. detect_usb_drive
  207. if [ ! -b $USB_DRIVE ]; then
  208. dialog --title $"Export music to USB drive" --msgbox $'No USB drive found' 6 50
  209. return
  210. fi
  211. backup_mount_drive ${USB_DRIVE}
  212. if [ ! -d $USB_MOUNT/Music ]; then
  213. mkdir -p $USB_MOUNT/Music
  214. fi
  215. cp -ru /music/* $USB_MOUNT/Music
  216. backup_unmount_drive ${USB_DRIVE}
  217. dialog --title $"Export music to USB drive" --msgbox $'Export complete. You may now remove the USB drive' 6 50
  218. }
  219. function format_music_drive {
  220. detect_usb_drive
  221. data=$(tempfile 2>/dev/null)
  222. trap "rm -f $data" 0 1 2 5 15
  223. dialog --title $"Format USB drive $USB_DRIVE for music storage" \
  224. --backtitle $"Freedombone Control Panel" \
  225. --defaultno \
  226. --yesno $"\nPlease confirm that you wish to format drive\n\n ${USB_DRIVE}\n\nAll current data on the drive will be lost, and you will be prompted to give a password used to encrypt the drive.\n\nDANGER: If you screw up here and format the wrong drive it's your own fault!" 16 60
  227. sel=$?
  228. case $sel in
  229. 1) return;;
  230. 255) return;;
  231. esac
  232. clear
  233. echo ''
  234. echo $"Formatting drive $USB_DRIVE. ALL CONTENTS WILL BE LOST."
  235. echo ''
  236. ${PROJECT_NAME}-format $USB_DRIVE
  237. dialog --title $"Format USB drive $USB_DRIVE for music storage" --msgbox $'Format complete. You may now export music or remove the USB drive' 6 50
  238. }
  239. function configure_interactive_koel {
  240. while true
  241. do
  242. data=$(tempfile 2>/dev/null)
  243. trap "rm -f $data" 0 1 2 5 15
  244. dialog --backtitle $"Freedombone Control Panel" \
  245. --title $"Koel" \
  246. --radiolist $"Choose an operation:" 12 70 5 \
  247. 1 $"Import music from directory" off \
  248. 2 $"Import music from USB drive" off \
  249. 3 $"Export music to USB drive" off \
  250. 4 $"Format a USB drive for music storage" off \
  251. 5 $"Exit" on 2> $data
  252. sel=$?
  253. case $sel in
  254. 1) break;;
  255. 255) break;;
  256. esac
  257. case $(cat $data) in
  258. 1) koel_import_from_directory;;
  259. 2) koel_import_from_usb;;
  260. 3) koel_export_to_usb;;
  261. 4) format_music_drive;;
  262. 5) break;;
  263. esac
  264. done
  265. }
  266. function upgrade_koel {
  267. if grep -q "koel domain" $COMPLETION_FILE; then
  268. KOEL_DOMAIN_NAME=$(get_completion_param "koel domain")
  269. fi
  270. CURR_KOEL_COMMIT=$(get_completion_param "koel commit")
  271. if [[ "$CURR_KOEL_COMMIT" == "$KOEL_COMMIT" ]]; then
  272. return
  273. fi
  274. systemctl stop koel
  275. # update to the next commit
  276. function_check set_repo_commit
  277. set_repo_commit /var/www/$KOEL_DOMAIN_NAME/htdocs "koel commit" "$KOEL_COMMIT" $KOEL_REPO
  278. cd /var/www/${KOEL_DOMAIN_NAME}/htdocs
  279. php artisan koel:init
  280. koel_remove_gravatar
  281. chown -R www-data:www-data *
  282. systemctl start koel
  283. }
  284. function backup_local_koel {
  285. KOEL_DOMAIN_NAME='koel'
  286. if grep -q "koel domain" $COMPLETION_FILE; then
  287. KOEL_DOMAIN_NAME=$(get_completion_param "koel domain")
  288. fi
  289. source_directory=/var/www/${KOEL_DOMAIN_NAME}/htdocs
  290. if [ -d $source_directory ]; then
  291. systemctl stop koel
  292. dest_directory=koel
  293. function_check suspend_site
  294. suspend_site ${KOEL_DOMAIN_NAME}
  295. function_check backup_directory_to_usb
  296. backup_directory_to_usb $source_directory $dest_directory
  297. function_check backup_database_to_usb
  298. backup_database_to_usb koel
  299. function_check restart_site
  300. restart_site
  301. systemctl start koel
  302. fi
  303. }
  304. function restore_local_koel {
  305. if ! grep -q "koel domain" $COMPLETION_FILE; then
  306. return
  307. fi
  308. KOEL_DOMAIN_NAME=$(get_completion_param "koel domain")
  309. if [ $KOEL_DOMAIN_NAME ]; then
  310. echo $"Restoring koel"
  311. systemctl stop koel
  312. temp_restore_dir=/root/tempkoel
  313. koel_dir=/var/www/${KOEL_DOMAIN_NAME}/htdocs
  314. function_check koel_create_database
  315. koel_create_database
  316. restore_database koel ${KOEL_DOMAIN_NAME}
  317. if [ -d $temp_restore_dir ]; then
  318. rm -rf $temp_restore_dir
  319. fi
  320. MARIADB_PASSWORD=$(${PROJECT_NAME}-pass -u root -a mariadb)
  321. cd /var/www/$KOEL_DOMAIN_NAME/htdocs
  322. sed -i "s|DB_PASSWORD=.*|DB_PASSWORD=$MARIADB_PASSWORD|g" .env
  323. MARIADB_PASSWORD=
  324. systemctl start koel
  325. fi
  326. }
  327. function backup_remote_koel {
  328. if grep -q "koel domain" $COMPLETION_FILE; then
  329. KOEL_DOMAIN_NAME=$(get_completion_param "koel domain")
  330. temp_backup_dir=/var/www/${KOEL_DOMAIN_NAME}/htdocs
  331. if [ -d $temp_backup_dir ]; then
  332. systemctl stop koel
  333. function_check suspend_site
  334. suspend_site ${KOEL_DOMAIN_NAME}
  335. function_check backup_database_to_friend
  336. backup_database_to_friend koel
  337. echo $"Backing up Koel installation"
  338. function_check backup_directory_to_friend
  339. backup_directory_to_friend $temp_backup_dir koel
  340. function_check restart_site
  341. restart_site
  342. systemctl start koel
  343. else
  344. echo $"koel domain specified but not found in ${temp_backup_dir}"
  345. fi
  346. fi
  347. }
  348. function restore_remote_koel {
  349. if grep -q "koel domain" $COMPLETION_FILE; then
  350. echo $"Restoring koel"
  351. systemctl stop koel
  352. KOEL_DOMAIN_NAME=$(get_completion_param "koel domain")
  353. function_check koel_create_database
  354. koel_create_database
  355. function_check restore_database_from_friend
  356. restore_database_from_friend koel ${KOEL_DOMAIN_NAME}
  357. if [ -d /root/tempkoel ]; then
  358. rm -rf /root/tempkoel
  359. fi
  360. MARIADB_PASSWORD=$(${PROJECT_NAME}-pass -u root -a mariadb)
  361. cd /var/www/$KOEL_DOMAIN_NAME/htdocs
  362. sed -i "s|DB_PASSWORD=.*|DB_PASSWORD=$MARIADB_PASSWORD|g" .env
  363. MARIADB_PASSWORD=
  364. systemctl start koel
  365. echo $"Restore of koel complete"
  366. fi
  367. }
  368. function remove_koel {
  369. if [ ${#KOEL_DOMAIN_NAME} -eq 0 ]; then
  370. return
  371. fi
  372. systemctl stop koel
  373. systemctl disable koel
  374. if [ -f /etc/systemd/system/koel.service ]; then
  375. rm /etc/systemd/system/koel.service
  376. fi
  377. systemctl daemon-reload
  378. function_check remove_nodejs
  379. remove_nodejs koel
  380. read_config_param "KOEL_DOMAIN_NAME"
  381. read_config_param "MY_USERNAME"
  382. echo "Removing $KOEL_DOMAIN_NAME"
  383. nginx_dissite $KOEL_DOMAIN_NAME
  384. remove_certs $KOEL_DOMAIN_NAME
  385. if [ -d /var/www/$KOEL_DOMAIN_NAME ]; then
  386. rm -rf /var/www/$KOEL_DOMAIN_NAME
  387. fi
  388. if [ -f /etc/nginx/sites-available/$KOEL_DOMAIN_NAME ]; then
  389. rm /etc/nginx/sites-available/$KOEL_DOMAIN_NAME
  390. fi
  391. function_check drop_database
  392. drop_database koel
  393. function_check remove_onion_service
  394. remove_onion_service koel ${KOEL_ONION_PORT}
  395. remove_app koel
  396. remove_completion_param install_koel
  397. sed -i '/koel/d' $COMPLETION_FILE
  398. remove_backup_database_local koel
  399. function_check remove_ddns_domain
  400. remove_ddns_domain $KOEL_DOMAIN_NAME
  401. }
  402. function install_koel_main {
  403. if [ ! $KOEL_DOMAIN_NAME ]; then
  404. echo $'No domain name was given for koel'
  405. exit 7359
  406. fi
  407. if [[ $(app_is_installed koel_main) == "1" ]]; then
  408. return
  409. fi
  410. function_check install_mariadb
  411. install_mariadb
  412. function_check get_mariadb_password
  413. get_mariadb_password
  414. function_check repair_databases_script
  415. repair_databases_script
  416. apt-get -yq install php-gettext php-curl php-gd php-mysql git curl php-zip
  417. apt-get -yq install php-memcached php-intl exiftool libfcgi0ldbl
  418. apt-get -yq install ffmpeg
  419. if [ ! -d /var/www/$KOEL_DOMAIN_NAME ]; then
  420. mkdir /var/www/$KOEL_DOMAIN_NAME
  421. fi
  422. if [ ! -d /var/www/$KOEL_DOMAIN_NAME/htdocs ]; then
  423. if [ -d /repos/koel ]; then
  424. mkdir /var/www/$KOEL_DOMAIN_NAME/htdocs
  425. cp -r -p /repos/koel/. /var/www/$KOEL_DOMAIN_NAME/htdocs
  426. cd /var/www/$KOEL_DOMAIN_NAME/htdocs
  427. git pull
  428. else
  429. function_check git_clone
  430. git_clone $KOEL_REPO /var/www/$KOEL_DOMAIN_NAME/htdocs
  431. fi
  432. if [ ! -d /var/www/$KOEL_DOMAIN_NAME/htdocs ]; then
  433. echo $'Unable to clone koel repo'
  434. exit 365735
  435. fi
  436. fi
  437. cd /var/www/$KOEL_DOMAIN_NAME/htdocs
  438. git checkout $KOEL_COMMIT -b $KOEL_COMMIT
  439. set_completion_param "koel commit" "$KOEL_COMMIT"
  440. chown -R www-data:www-data /var/www/$KOEL_DOMAIN_NAME/htdocs
  441. function_check koel_create_database
  442. koel_create_database
  443. function_check add_ddns_domain
  444. add_ddns_domain $KOEL_DOMAIN_NAME
  445. koel_nginx_site=/etc/nginx/sites-available/$KOEL_DOMAIN_NAME
  446. if [[ $ONION_ONLY == "no" ]]; then
  447. function_check nginx_http_redirect
  448. nginx_http_redirect $KOEL_DOMAIN_NAME "index index.php"
  449. echo 'server {' >> $koel_nginx_site
  450. echo ' listen 443 ssl;' >> $koel_nginx_site
  451. echo ' listen [::]:443 ssl;' >> $koel_nginx_site
  452. echo " server_name $KOEL_DOMAIN_NAME;" >> $koel_nginx_site
  453. echo '' >> $koel_nginx_site
  454. function_check nginx_compress
  455. nginx_compress $KOEL_DOMAIN_NAME
  456. echo ' gzip_comp_level 9;' >> $koel_nginx_site
  457. echo '' >> $koel_nginx_site
  458. echo ' # Security' >> $koel_nginx_site
  459. function_check nginx_ssl mobile
  460. nginx_ssl $KOEL_DOMAIN_NAME
  461. function_check nginx_disable_sniffing
  462. nginx_disable_sniffing $KOEL_DOMAIN_NAME
  463. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $koel_nginx_site
  464. echo '' >> $koel_nginx_site
  465. echo ' # Logs' >> $koel_nginx_site
  466. echo ' access_log /dev/null;' >> $koel_nginx_site
  467. echo ' error_log /dev/null;' >> $koel_nginx_site
  468. echo '' >> $koel_nginx_site
  469. echo ' # Root' >> $koel_nginx_site
  470. echo " root /var/www/$KOEL_DOMAIN_NAME/htdocs;" >> $koel_nginx_site
  471. echo '' >> $koel_nginx_site
  472. echo ' # Index' >> $koel_nginx_site
  473. echo ' index index.php;' >> $koel_nginx_site
  474. echo '' >> $koel_nginx_site
  475. echo ' # Whitelist only index.php, robots.txt, and those start with public/ or api/' >> $koel_nginx_site
  476. echo ' if ($request_uri !~ ^/$|index\.php|robots\.txt|api/|public/) {' >> $koel_nginx_site
  477. echo ' return 404;' >> $koel_nginx_site
  478. echo ' }' >> $koel_nginx_site
  479. echo '' >> $koel_nginx_site
  480. echo ' location /media/ {' >> $koel_nginx_site
  481. echo ' internal;' >> $koel_nginx_site
  482. echo '' >> $koel_nginx_site
  483. echo ' # A X-Media-Root should be set to media_path settings from upstream' >> $koel_nginx_site
  484. echo ' alias $upstream_http_x_media_root;' >> $koel_nginx_site
  485. echo '' >> $koel_nginx_site
  486. echo ' }' >> $koel_nginx_site
  487. echo '' >> $koel_nginx_site
  488. echo ' # PHP' >> $koel_nginx_site
  489. echo ' location ~ \.php {' >> $koel_nginx_site
  490. echo ' include snippets/fastcgi-php.conf;' >> $koel_nginx_site
  491. echo ' fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;' >> $koel_nginx_site
  492. echo ' fastcgi_read_timeout 30;' >> $koel_nginx_site
  493. echo ' }' >> $koel_nginx_site
  494. echo '' >> $koel_nginx_site
  495. echo ' # Location' >> $koel_nginx_site
  496. echo ' location / {' >> $koel_nginx_site
  497. function_check nginx_limits
  498. nginx_limits $KOEL_DOMAIN_NAME '15m'
  499. echo ' try_files $uri $uri/ @koel;' >> $koel_nginx_site
  500. echo ' }' >> $koel_nginx_site
  501. echo '' >> $koel_nginx_site
  502. echo ' # Fancy URLs' >> $koel_nginx_site
  503. echo ' location @koel {' >> $koel_nginx_site
  504. echo ' rewrite ^(.*)$ /index.php?p=$1 last;' >> $koel_nginx_site
  505. echo ' }' >> $koel_nginx_site
  506. echo '' >> $koel_nginx_site
  507. echo ' # Restrict access that is unnecessary anyway' >> $koel_nginx_site
  508. echo ' location ~ /\.(ht|git) {' >> $koel_nginx_site
  509. echo ' deny all;' >> $koel_nginx_site
  510. echo ' }' >> $koel_nginx_site
  511. echo '' >> $koel_nginx_site
  512. echo '}' >> $koel_nginx_site
  513. else
  514. echo -n '' > $koel_nginx_site
  515. fi
  516. echo 'server {' >> $koel_nginx_site
  517. echo " listen 127.0.0.1:$KOEL_ONION_PORT default_server;" >> $koel_nginx_site
  518. echo " server_name $KOEL_DOMAIN_NAME;" >> $koel_nginx_site
  519. echo '' >> $koel_nginx_site
  520. function_check nginx_compress
  521. nginx_compress $KOEL_DOMAIN_NAME
  522. echo ' gzip_comp_level 9;' >> $koel_nginx_site
  523. echo '' >> $koel_nginx_site
  524. echo ' # Logs' >> $koel_nginx_site
  525. echo ' access_log /dev/null;' >> $koel_nginx_site
  526. echo ' error_log /dev/null;' >> $koel_nginx_site
  527. echo '' >> $koel_nginx_site
  528. echo ' # Root' >> $koel_nginx_site
  529. echo " root /var/www/$KOEL_DOMAIN_NAME/htdocs;" >> $koel_nginx_site
  530. echo '' >> $koel_nginx_site
  531. echo ' # Index' >> $koel_nginx_site
  532. echo ' index index.php;' >> $koel_nginx_site
  533. echo '' >> $koel_nginx_site
  534. echo ' # Whitelist only index.php, robots.txt, and those start with public/ or api/' >> $koel_nginx_site
  535. echo ' if ($request_uri !~ ^/$|index\.php|robots\.txt|api/|public/) {' >> $koel_nginx_site
  536. echo ' return 404;' >> $koel_nginx_site
  537. echo ' }' >> $koel_nginx_site
  538. echo '' >> $koel_nginx_site
  539. echo ' location /media/ {' >> $koel_nginx_site
  540. echo ' internal;' >> $koel_nginx_site
  541. echo '' >> $koel_nginx_site
  542. echo ' # A X-Media-Root should be set to media_path settings from upstream' >> $koel_nginx_site
  543. echo ' alias $upstream_http_x_media_root;' >> $koel_nginx_site
  544. echo '' >> $koel_nginx_site
  545. echo ' }' >> $koel_nginx_site
  546. echo '' >> $koel_nginx_site
  547. echo ' # PHP' >> $koel_nginx_site
  548. echo ' location ~ \.php {' >> $koel_nginx_site
  549. echo ' include snippets/fastcgi-php.conf;' >> $koel_nginx_site
  550. echo ' fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;' >> $koel_nginx_site
  551. echo ' fastcgi_read_timeout 30;' >> $koel_nginx_site
  552. echo ' }' >> $koel_nginx_site
  553. echo '' >> $koel_nginx_site
  554. echo ' # Location' >> $koel_nginx_site
  555. echo ' location / {' >> $koel_nginx_site
  556. function_check nginx_limits
  557. nginx_limits $KOEL_DOMAIN_NAME '15m'
  558. echo ' try_files $uri $uri/ @koel;' >> $koel_nginx_site
  559. echo ' }' >> $koel_nginx_site
  560. echo '' >> $koel_nginx_site
  561. echo ' # Fancy URLs' >> $koel_nginx_site
  562. echo ' location @koel {' >> $koel_nginx_site
  563. echo ' rewrite ^(.*)$ /index.php?p=$1 last;' >> $koel_nginx_site
  564. echo ' }' >> $koel_nginx_site
  565. echo '' >> $koel_nginx_site
  566. echo ' # Restrict access that is unnecessary anyway' >> $koel_nginx_site
  567. echo ' location ~ /\.(ht|git) {' >> $koel_nginx_site
  568. echo ' deny all;' >> $koel_nginx_site
  569. echo ' }' >> $koel_nginx_site
  570. echo '' >> $koel_nginx_site
  571. echo '}' >> $koel_nginx_site
  572. sed -i 's|gzip_types.*|gzip_types text/plain text/css application/x-javascript text/xml application/xml application/xml+rss text/javascript application/json;|g' $koel_nginx_site
  573. sed -i 's|DENY;|SAMEORIGIN;|g' $koel_nginx_site
  574. function_check configure_php
  575. configure_php
  576. function_check create_site_certificate
  577. create_site_certificate $KOEL_DOMAIN_NAME 'yes'
  578. # Ensure that the database gets backed up locally, if remote
  579. # backups are not being used
  580. function_check backup_databases_script_header
  581. backup_databases_script_header
  582. function_check backup_database_local
  583. backup_database_local koel
  584. function_check nginx_ensite
  585. nginx_ensite $KOEL_DOMAIN_NAME
  586. KOEL_ONION_HOSTNAME=$(add_onion_service koel 80 ${KOEL_ONION_PORT})
  587. KOEL_SERVER=${KOEL_DOMAIN_NAME}
  588. if [[ $ONION_ONLY != 'no' ]]; then
  589. KOEL_SERVER=${KOEL_ONION_HOSTNAME}
  590. fi
  591. systemctl restart mariadb
  592. systemctl restart php7.0-fpm
  593. systemctl restart nginx
  594. ${PROJECT_NAME}-pass -u $MY_USERNAME -a koel -p "$KOEL_ADMIN_PASSWORD"
  595. set_completion_param "koel domain" "$KOEL_DOMAIN_NAME"
  596. install_completed koel_main
  597. }
  598. function install_koel {
  599. if [ ! $ONION_ONLY ]; then
  600. ONION_ONLY='no'
  601. fi
  602. function_check install_nodejs
  603. install_nodejs koel
  604. install_koel_main
  605. cd /var/www/$KOEL_DOMAIN_NAME/htdocs
  606. install_composer
  607. npm install -g yarn
  608. npm install
  609. function_check get_mariadb_password
  610. get_mariadb_password
  611. cp .env.example .env
  612. sed -i "s/ADMIN_EMAIL=.*/ADMIN_EMAIL=$MY_EMAIL_ADDRESS/g" .env
  613. sed -i "s/ADMIN_NAME=.*/ADMIN_NAME=$MY_USERNAME/g" .env
  614. sed -i "s/ADMIN_PASSWORD=.*/ADMIN_PASSWORD=$KOEL_ADMIN_PASSWORD/g" .env
  615. sed -i 's/DB_CONNECTION=.*/DB_CONNECTION=mysql/g' .env
  616. sed -i 's/DB_HOST=.*/DB_HOST=127.0.0.1/g' .env
  617. sed -i 's/DB_DATABASE=.*/DB_DATABASE=koel/g' .env
  618. sed -i 's/DB_USERNAME=.*/DB_USERNAME=root/g' .env
  619. sed -i "s|DB_PASSWORD=.*|DB_PASSWORD=$MARIADB_PASSWORD|g" .env
  620. sed -i 's/MAIL_HOST=.*/MAIL_HOST=localhost/g' .env
  621. sed -i 's/MAIL_PORT=.*/MAIL_PORT=25/g' .env
  622. sed -i 's|FFMPEG_PATH=.*|FFMPEG_PATH=/usr/bin/ffmpeg|g' .env
  623. php artisan koel:init
  624. if [ ! "$?" = "0" ]; then
  625. echo $"Can't install koel:init"
  626. exit 78362
  627. fi
  628. koel_remove_gravatar
  629. chown -R www-data:www-data /var/www/$KOEL_DOMAIN_NAME/htdocs
  630. # daemon
  631. echo '[Unit]' > /etc/systemd/system/koel.service
  632. echo 'Description=Koel (music player)' >> /etc/systemd/system/koel.service
  633. echo 'After=syslog.target' >> /etc/systemd/system/koel.service
  634. echo 'After=network.target' >> /etc/systemd/system/koel.service
  635. echo '' >> /etc/systemd/system/koel.service
  636. echo '[Service]' >> /etc/systemd/system/koel.service
  637. echo 'Type=simple' >> /etc/systemd/system/koel.service
  638. echo 'User=www-data' >> /etc/systemd/system/koel.service
  639. echo 'Group=www-data' >> /etc/systemd/system/koel.service
  640. echo "WorkingDirectory=/var/www/$KOEL_DOMAIN_NAME/htdocs" >> /etc/systemd/system/koel.service
  641. echo "ExecStart=/usr/bin/php artisan serve --port=$KOEL_PORT" >> /etc/systemd/system/koel.service
  642. echo 'Restart=on-failure' >> /etc/systemd/system/koel.service
  643. echo '' >> /etc/systemd/system/koel.service
  644. echo '[Install]' >> /etc/systemd/system/koel.service
  645. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/koel.service
  646. systemctl enable koel.service
  647. systemctl daemon-reload
  648. systemctl start koel.service
  649. if [ ! -d /music ]; then
  650. mkdir /music
  651. fi
  652. chown -R www-data:www-data /music
  653. systemctl restart mariadb
  654. systemctl restart nginx
  655. APP_INSTALLED=1
  656. }
  657. # NOTE: deliberately there is no "exit 0"